/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CSTR                                                     */
/* Tabela : CODSITUTRIB                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CSTR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CSTR
GO

CREATE TRIGGER DTULTATU_CSTR
ON CODSITUTRIB
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_COUNT INTEGER;
   DECLARE @V_TESTE VARCHAR(10)
BEGIN

   SELECT @V_COUNT = COUNT(*)
     FROM  DELETED
    WHERE NRINCIDCST NOT IN (SELECT NRINCIDCST FROM INSERTED);

   IF (@V_COUNT > 0) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CODSITUTRIB', null, 'NRINCIDCST=' + NRINCIDCST + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN

      SELECT @V_TESTE = INSERTED.NRINCIDCST
      FROM INSERTED, DELETED
      WHERE INSERTED.NRINCIDCST = DELETED.NRINCIDCST
      UNION ALL
      SELECT @V_TESTE = NRINCIDCST
      FROM INSERTED
      WHERE NRINCIDCST NOT IN (SELECT NRINCIDCST FROM DELETED);

      UPDATE CODSITUTRIB
      SET DTULTATUCSTR = GETDATE()
      WHERE  NRINCIDCST = @V_TESTE;

   END;
END;
GO

